# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <math.h>
# include <vector>
using namespace std;

void	dec2bin(int x,vector<int> &y)
{
	int i=0;
	while(x>0)
	{
		y.resize(i+1);
		y[i]=x%2;
		x=x/2;
		i=i+1;
	}

}

void	print(vector<int> x)
{
	for(int i=0;i<x.size();i++) printf("%d",x[i]);
	printf("\n");
}

void	reverse(vector<int> &x)
{
	vector<int> y;
	y=x;
	for(int i=0;i<x.size();i++)
	{
		y[i]=x[x.size()-i-1];
	}
	x=y;
}

void	convert(double x,double xmin,double xmax,int N,vector<int> &b)
{
	int k=(int)((x-xmin)/(xmax-xmin)*pow(2.0,N-1));
	dec2bin(k,b);
	reverse(b);
}

int main()
{
	double xmin,xmax,x;
	int N;
	vector<int> b;
	do{
		printf("ENTER XMIN? ");
		scanf("%lf",&xmin);
		printf("ENTER XMAX? ");
		scanf("%lf",&xmax);
	}while(xmin>=xmax);
	do
	{
		printf("ENTER X ?");
		scanf("%lf",&x);
	}while(x>xmax || x<xmin);
	do
	{
		printf("ENTER NUMBER OF AVAILABLE BINARY DIGITS ?");
		scanf("%d",&N);
	}while(N<=0);
	convert(x,xmin,xmax,N,b);
	printf("THE PRODUCED CHROMOSOME IS ");
	print(b);
	return 0;
}
